"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_native_reanimated_1 = __importStar(require("react-native-reanimated"));
// @ts-ignore
var base_1 = require("react-native-reanimated/src/base");
var Clock = react_native_reanimated_1.default.Clock, Value = react_native_reanimated_1.default.Value, block = react_native_reanimated_1.default.block, timing = react_native_reanimated_1.default.timing, call = react_native_reanimated_1.default.call, cond = react_native_reanimated_1.default.cond, stopClock = react_native_reanimated_1.default.stopClock, set = react_native_reanimated_1.default.set, startClock = react_native_reanimated_1.default.startClock, clockRunning = react_native_reanimated_1.default.clockRunning, onChange = react_native_reanimated_1.default.onChange;
exports.runTiming = function (master, duration, callback) {
    var clock = new Clock();
    var animation;
    animation = base_1.always(internalRunTiming(clock, master, {
        toValue: duration,
        duration: duration,
        easing: react_native_reanimated_1.Easing.linear
    }, function () {
        // @ts-ignore
        animation.__detach();
        callback && callback();
    }));
    // @ts-ignore
    animation.__attach();
};
function internalRunTiming(clock, value, config, callback) {
    var state = {
        finished: new Value(0),
        position: new Value(0),
        time: new Value(0),
        frameTime: new Value(0)
    };
    return block([
        onChange(config.toValue, set(state.frameTime, 0)),
        cond(clockRunning(clock), 0, [
            set(state.finished, 0),
            set(state.time, 0),
            set(value, state.position),
            set(state.frameTime, 0),
            startClock(clock)
        ]),
        timing(clock, state, config),
        set(value, state.position),
        cond(state.finished, [stopClock(clock), call([], callback)])
    ]);
}
//# sourceMappingURL=runTiming.js.map