"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_native_reanimated_1 = __importStar(require("react-native-reanimated"));
var runTiming_1 = require("./Implementation/runTiming");
var createValue_1 = require("./Implementation/createValue");
var getProcessedColor_1 = require("./Implementation/getProcessedColor");
var getProcessedRotation_1 = require("./Implementation/getProcessedRotation");
var utils_1 = require("./Implementation/utils");
// @ts-ignore
var base_1 = require("react-native-reanimated/src/base");
var event = react_native_reanimated_1.default.event, abs = react_native_reanimated_1.default.abs, add = react_native_reanimated_1.default.add, multiply = react_native_reanimated_1.default.multiply, round = react_native_reanimated_1.default.round, cond = react_native_reanimated_1.default.cond, set = react_native_reanimated_1.default.set, eq = react_native_reanimated_1.default.eq, neq = react_native_reanimated_1.default.neq, divide = react_native_reanimated_1.default.divide, sub = react_native_reanimated_1.default.sub, call = react_native_reanimated_1.default.call, block = react_native_reanimated_1.default.block, and = react_native_reanimated_1.default.and, proc = react_native_reanimated_1.default.proc, greaterOrEq = react_native_reanimated_1.default.greaterOrEq, lessThan = react_native_reanimated_1.default.lessThan, greaterThan = react_native_reanimated_1.default.greaterThan, lessOrEq = react_native_reanimated_1.default.lessOrEq, pow = react_native_reanimated_1.default.pow, cos = react_native_reanimated_1.default.cos, sin = react_native_reanimated_1.default.sin, exp = react_native_reanimated_1.default.exp, sqrt = react_native_reanimated_1.default.sqrt;
var ReanimatedAnimationProvider = {
    runTiming: runTiming_1.runTiming,
    createValue: createValue_1.createValue,
    getNumericColor: getProcessedColor_1.getProcessedColor,
    getNumericRotation: getProcessedRotation_1.getProcessedRotation,
    isAnimatedNode: utils_1.isAnimatedNode,
    createAnimatedComponent: react_native_reanimated_1.default.createAnimatedComponent,
    getColorDisplayValue: function (input) { return input; },
    getRadianDisplayValue: function (input) { return input; },
    //concat(input as Animated.Value<number>, "rad"),
    getDisplayValue: function (input) { return input; },
    configuration: {
        gestureConfiguration: { useNativeDriver: true },
    },
    Types: {
        View: react_native_reanimated_1.default.View,
        Image: react_native_reanimated_1.default.Image,
        ScrollView: react_native_reanimated_1.default.ScrollView,
        Text: react_native_reanimated_1.default.Text,
    },
    Animated: {
        // @ts-ignore
        event: event,
        round: function (a) { return round(a); },
        multiply: function (a, b) {
            var others = [];
            for (var _i = 2; _i < arguments.length; _i++) {
                others[_i - 2] = arguments[_i];
            }
            return multiply.apply(void 0, __spreadArrays([a,
                b], others));
        },
        add: function (a, b) {
            var others = [];
            for (var _i = 2; _i < arguments.length; _i++) {
                others[_i - 2] = arguments[_i];
            }
            return add.apply(void 0, __spreadArrays([a,
                b], others));
        },
        sub: function (a, b) {
            return sub(a, b);
        },
        debug: function (message, a) {
            return __DEV__
                ? call([a], function (args) { return console.log(message, args[0]); })
                : react_native_reanimated_1.default.debug(message, a);
        },
        cond: function (condNode, ifNode, elseNode) {
            return cond(condNode, ifNode, elseNode);
        },
        set: function (a, b) {
            return set(a, b);
        },
        eq: function (a, b) {
            return eq(a, b);
        },
        neq: function (a, b) {
            return neq(a, b);
        },
        divide: function (a, b) {
            return divide(a, b);
        },
        // @ts-ignore
        call: call,
        block: block,
        and: function (a, b) {
            var others = [];
            for (var _i = 2; _i < arguments.length; _i++) {
                others[_i - 2] = arguments[_i];
            }
            return and.apply(void 0, __spreadArrays([a,
                b], others));
        },
        proc: function (_, cb) { return proc(cb); },
        greaterOrEq: function (a, b) {
            return greaterOrEq(a, b);
        },
        lessThan: function (a, b) {
            return lessThan(a, b);
        },
        greaterThan: function (a, b) {
            return greaterThan(a, b);
        },
        pow: function (a, b) {
            return pow(a, b);
        },
        cos: function (a) { return cos(a); },
        sin: function (a) { return sin(a); },
        sqrt: function (a) { return sqrt(a); },
        abs: function (a) { return abs(a); },
        lessOrEq: function (left, right) {
            return lessOrEq(left, right);
        },
        exp: function (a) { return exp(a); },
        always: function (cb) { return base_1.always(cb()); },
        attach: function (_source, node) {
            // @ts-ignore
            node.__attach();
        },
        detach: function (_source, node) {
            // @ts-ignore
            return node.__detach();
        },
        // @ts-ignore
        bezier: function (x1, y1, x2, y2) {
            return react_native_reanimated_1.Easing.bezier(x1, y1, x2, y2);
        },
    },
};
exports.ReanimatedAnimationProvider = ReanimatedAnimationProvider;
//# sourceMappingURL=index.native.js.map